'--- 16F877A PIC met 20 Mhz kristal ---
Device = 16F877A
XTAL = 20

'--- alle poorten als I/O definiren (geen DAC/RS232 etc ...)
ALL_DIGITAL = true

'--- definier input poorten (Schakelaars) ---
Input PORTA.0
Input PORTA.1
Input PORTA.2
Input PORTE.0
Input PORTE.1
Input PORTE.2
Input PORTC.2
Input PORTC.3
Input PORTD.0
Input PORTD.1
Input PORTD.2
Input PORTD.3
Input PORTD.4
Input PORTD.5

'--- definier output poorten (LEDs) ---
Output PORTC.6
Output PORTC.7
Output PORTD.4
Output PORTD.5
Output PORTD.6
Output PORTD.7
Output PORTB.7
Output PORTB.6
Output PORTB.5
Output PORTB.4
Output PORTB.3
Output PORTB.2
Output PORTB.1
Output PORTB.0

'--- definier variabelen voor EEPROM gebruik ---
Dim poort1 As Byte
Dim poort2 As Byte
Dim poort3 As Byte
Dim poort4 As Byte
Dim poort5 As Byte
Dim poort6 As Byte
Dim poort7 As Byte

'--- Zet alle LEDs aan, zodat bij stroom inschakelen, kan gecontroleerd worden of alle LEDs nog werken ---
High PORTC.6
High PORTC.7
High PORTD.4
High PORTD.5
High PORTD.6
High PORTD.7
High PORTB.7
High PORTB.6
High PORTB.5
High PORTB.4
High PORTB.3
High PORTB.2
High PORTB.1
High PORTB.0

'--- wacht 5 seconden ---
DelayMS 5000

'--- lees stand van LEDs uit, zodat na stroom-uitschakeling, status toch nog recent is ---
'--- leg EEPROM adressen wat uit mekaar !                                              ---
poort1 = ERead 10
poort2 = ERead 20
poort3 = ERead 30
poort4 = ERead 40
poort5 = ERead 50
poort6 = ERead 60
poort7 = ERead 70

'--- update alle LEDs volgens status voor stroomuitschakeling ---
If poort1 = 1 Then
    High PORTB.7
    Low PORTB.6
Else
    Low PORTB.7
    High PORTB.6
EndIf
If poort2 = 1 Then
    High PORTB.5
    Low PORTB.4
Else
    Low PORTB.5
    High PORTB.4
EndIf
If poort3 = 1 Then
    High PORTB.3
    Low PORTB.2
Else
    Low PORTB.3
    High PORTB.2
EndIf
If poort4 = 1 Then
    High PORTB.1
    Low PORTB.0
Else
    Low PORTB.1
    High PORTB.0
EndIf
If poort5 = 1 Then
    High PORTD.7
    Low PORTD.6
Else
    Low PORTD.7
    High PORTD.6
EndIf
If poort6 = 1 Then
    High PORTD.5
    Low PORTD.4
Else
    Low PORTD.5
    High PORTD.4
EndIf
If poort7 = 1 Then
    High PORTC.7
    Low PORTC.6
Else
    Low PORTC.7
    High PORTC.6
EndIf


'--- oneindige lus (eigenlijke logica om pulsen in blijvend oplichtende LEDs om te zetten ---
While 1 = 1
    '--- port 1 ---
    If PORTA.0 = 1 Then
        High PORTB.7    
        Low PORTB.6
        poort1 = ERead 10
        If poort1 <> 1 Then
            poort1 = 1
            EWrite 10,[poort1]
        EndIf
    EndIf
    If PORTA.1 = 1 Then
        Low PORTB.7    
        High PORTB.6
        poort1 = ERead 10
        If poort1 <> 0 Then
            poort1 = 0
            EWrite 10,[poort1]
        EndIf
    EndIf
    '--- port 2 ---
    If PORTA.2 = 1 Then
        High PORTB.5    
        Low PORTB.4
        poort2 = ERead 20
        If poort2 <> 1 Then
            poort2 = 1
            EWrite 20,[poort2]
        EndIf
    EndIf
    If PORTE.0 = 1 Then
        Low PORTB.5    
        High PORTB.4
        poort2 = ERead 20
        If poort2 <> 0 Then
            poort2 = 0
            EWrite 20,[poort2]
        EndIf
    EndIf    
    '--- port 3 ---
    If PORTE.1 = 1 Then
        High PORTB.3    
        Low PORTB.2
        poort3 = ERead 30
        If poort3 <> 1 Then
            poort3 = 1
            EWrite 30,[poort3]
        EndIf
    EndIf
    If PORTE.2 = 1 Then
        Low PORTB.3    
        High PORTB.2
        poort3 = ERead 30
        If poort3 <> 0 Then
            poort3 = 0
            EWrite 30,[poort3]
        EndIf
    EndIf    
    '--- port 4 ---
    If PORTC.2 = 1 Then
        High PORTB.1    
        Low PORTB.0
        poort4 = ERead 40
        If poort4 <> 1 Then
            poort4 = 1
            EWrite 40,[poort4]
        EndIf
    EndIf
    If PORTC.3 = 1 Then
        Low PORTB.1    
        High PORTB.0
        poort4 = ERead 40
        If poort4 <> 0 Then
            poort4 = 0
            EWrite 40,[poort4]
        EndIf
    EndIf    
    '--- port 5 ---
    If PORTD.0 = 1 Then
        High PORTD.7    
        Low PORTD.6
        poort5 = ERead 50
        If poort5 <> 1 Then
            poort5 = 1
            EWrite 50,[poort5]
        EndIf
    EndIf
    If PORTD.1 = 1 Then
        Low PORTD.7    
        High PORTD.6
        poort5 = ERead 50
        If poort5 <> 0 Then
            poort5 = 0
            EWrite 50,[poort5]
        EndIf
    EndIf    
    '--- port 6 ---
    If PORTD.2 = 1 Then
        High PORTD.5    
        Low PORTD.4
        poort6 = ERead 60
        If poort6 <> 1 Then
            poort6 = 1
            EWrite 60,[poort6]
        EndIf
    EndIf
    If PORTD.3 = 1 Then
        Low PORTD.5    
        High PORTD.4
        poort6 = ERead 60
        If poort6 <> 0 Then
            poort6 = 0
            EWrite 60,[poort6]
        EndIf
    EndIf    
    '--- port 7 ---
   If PORTC.4 = 1 Then
        High PORTC.7    
        Low PORTC.6
        poort7 = ERead 70
        If poort7 <> 1 Then
            poort7 = 1
            EWrite 70,[poort7]
        EndIf
    EndIf
    If PORTC.5 = 1 Then
        Low PORTC.7    
        High PORTC.6
        poort7 = ERead 70
        If poort7 <> 0 Then
            poort7 = 0
            EWrite 70,[poort7]
        EndIf
   EndIf    
 Wend


